Connections
The CJA Connections APIs allow you to retrieve connections programmatically through Adobe Developer. These APIs use the same data and methods that Adobe uses inside the product UI. See Connections in the Customer Journey Analytics guide for more information.
The endpoints described in this guide are routed through analytics.adobe.io. To use them, you will need to first create a client with access to Customer Journey Analytics APIs. For more information, refer to Getting started with the Customer Journey Analytics API.
data-variant=info
data-slots=text
data-variant=info
data-slots=text
This guide includes instructions for using the following endpoints:
- GET connection by ID: Retrieve a specific connection by connection ID
- GET all connections: Retrieve all connections for an organization
- GET backfills: Retrieve all backfills for a dataset and connection pair.
- GET data source types: Retrieve all data source types for an organization
GET connection by ID
Use this endpoint to retrieve the data for a specific connection by using the connection ID.
GET https://cja.adobe.io/data/connections/{CONNECTION_ID}
Request and Response Examples
Click the Request tab in the following example to see a cURL request for this endpoint. Click the Response tab to see a successful JSON response for the request.
data-slots=heading, code
data-repeat=2
data-languages=CURL,JSON
Request
curl 'https://cja.adobe.io/data/connections/dg_b008fd39-2437-4d00-88fd-392437XXXXXX?expansion=name%2Cdescription%2Cowner%2CdataSets%2CexternalData%2CschemaInfo' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {IMS_ORG_ID}' \
-H 'Authorization: Bearer {AUTHORIZATION_TOKEN}'
Response
{
"name": "Test Connection",
"description": "A test connection.",
"owner": {
"imsUserId": "{IMS_USER_ID}",
"ownerId": "{OWNER_ID}",
"name": null,
"type": "imsUser"
},
"dataSets": [
{
"dataSetId": "5f24c4f6ecffd11638XXXXXX",
"domain": "catalog",
"type": "event",
"timestampId": "timestamp",
"visitorId": "_exampleorg.team.id",
"identityNamespace": "teamid",
"usePrimaryIdNamespace": false,
"identityMap": false,
"name": "Test Dataset",
"schemaInfo": {
"schemaId": "https://ns.adobe.com/exampleorg/schemas/105f3200745a921d8bee745227760b0cd8c3055273XXXXXX",
"schemaName": "Example Schema"
},
"streaming": true
}
],
"externalData": {
"externalId": "b008fd39-2437-4d00-88fd-392437XXXXXX"
},
"idWithoutPrefix": "b008fd39-2437-4d00-88fd-392437XXXXXX",
"id": "dg_b008fd39-2437-4d00-88fd-392437XXXXXX"
}
Request Example Details
The example above requests the following:
- The information associated with the connection ID
dg_b008fd39-2437-4d00-88fd-392437XXXXXX. - The
dataSetsassociated with the connection. - The
schemaInfoassociated with the dataset.
Response Example Details
The example response above shows the following:
- The only
dataSetIdused by the connection is5f24c4f6ecffd116XXXXXX. - The
typeof dataset used isevent. - The name of the schema used by the dataset is
Example Schema. - The connection ID is
dg_b008fd39-2437-4d00-88fd-392437XXXXXX.
Request Parameters
connectionIdexpansionname, description, owner, isDeleted, isDisabled, dataSets, createdDate, modified, caseSensitive, organization, components, numDailyEvents, externalData, backfillEnabled, granularBackfills, granularStreaming, backfillsSummaryConnection, backfillsSummaryDataSets, dataSetLastIngested, sandboxName, sandboxId, fieldsId, floatPrecision, dataRetentionMonths, validationErrors, resolveIdentityNamespace, stitchedDataSets, ownerFullName, schemaInfo, and tags.localeResponse Parameters
namedescriptionownerimsUserId, ownerId, name, and type parameters.imsUserIdownerIdnametypedataSetsdataSetId, domain, type, timestampId, visitorId, lookupKeyField, lookupParentFields, lookupParentDataSetId, lookupParentDataSetType, identityNamespace, usePrimaryIdNamespace, identityMap, name, schemaInfo, streaming, backfillSummary, lastIngestedTime, streamingEnabledAt, identityNamespaceCol, and dataSourceType parameters.dataSetIddomaintypetimestampIdvisitorIdlookupKeyFieldlookupParentFieldslookupParentDataSetIdlookupParentDataSetTypeidentityNamespaceusePrimaryIdNamespaceidentityMapnameschemaInfoschemaId, schemaName, and schemaRef parameters.schemaIdschemaNameschemaRefid and contentType parameters.idcontentTypebackfillsid, dataSetId, status, startDate, endDate, createdDate, and allData parameters.iddataSetIdstatusstartDateendDatecreatedDateallDatastreamingbackfillSummarytotal, failed, inProgress, completed, and invalid parameters.totalfailedinProgresscompletedinvalidlastIngestedTimestreamingEnabledAtidentityNamespaceColdataSourceTypeid, type, and description parameters.idtypedescriptionidentityNamespaceDatadataSetId, domain, identityNamespace, usePrimaryIdNamespace, identityMap, and identityNamespaceCol parameters.dataSetIddomainidentityNamespaceColmodifiedDatecreatedDateorganizationmodifiedBymodifiedByFullNamecaseSensitivenumDailyEventsexternalDataexternalId and externalParentId parameters.externalIdexternalParentIdbackfillEnabledsandboxIdsandboxNamefieldsIdfloatPrecisiondataRetentionMonthsconnectionValidationErrorserrorCode, dataSetId, dataSetName, disallowedField, and missingField parameters.errorCodedataSetIddataSetNamedisallowedFieldmissingFieldidWithoutPrefixdg_ prefixidGET all connections
Use this endpoint to retrieve all connections associated with an organization.
GET https://cja.adobe.io/data/connections
Request and Response Examples
Click the Request tab in the following example to see a cURL request for this endpoint. Click the Response tab to see a successful JSON response for the request.
data-slots=heading, code
data-repeat=2
data-languages=CURL,JSON
Request
curl 'https://cja.adobe.io/data/connections?expansion=name%2Cdescription%2Cowner%2CdataSets&limit=2&sortDirection=DESC' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {IMS_ORG_ID}' \
-H 'Authorization: Bearer {AUTHORIZATION_TOKEN}'
Response
{
"content": [
{
"name": "Test Connection",
"description": "A test connection.",
"owner": {
"imsUserId": "{IMS_USER_ID}",
"ownerId": "{OWNER_ID}",
"name": null,
"type": "imsUser"
},
"dataSets": [
{
"dataSetId": "5f24c4f6ecffd13h6dXXXXXX",
"domain": "catalog",
"type": "event",
"timestampId": "timestamp",
"visitorId": "_exampleorg.team.id",
"identityNamespace": "teamid",
"usePrimaryIdNamespace": false,
"identityMap": false,
"name": "Test Dataset",
"streaming": true
}
],
"idWithoutPrefix": "b008fd39-2437-4d00-88fd-392434XXXXXX",
"id": "dg_b008fd39-2437-4d00-88fd-392434XXXXXX"
},
{
"name": "test123",
"description": "",
"owner": {
"imsUserId": "{IMS_USER_ID}",
"ownerId": "{OWNER_ID}",
"name": null,
"type": "imsUser"
},
"dataSets": [
{
"dataSetId": "5f1873caa73caa4hf6XXXXXX",
"domain": "catalog",
"type": "event",
"timestampId": "timestamp",
"visitorId": "_id",
"identityNamespace": "Email",
"usePrimaryIdNamespace": false,
"identityMap": false,
"name": "example_object_event",
"streaming": true
}
],
"idWithoutPrefix": "7110bb3e-76ce-4201-90bb-3e7656XXXXXX",
"id": "dg_7110bb3e-76ce-4201-90bb-3e7656XXXXXX"
}
],
"number": 0,
"totalElements": 573,
"totalPages": 287,
"numberOfElements": 2,
"firstPage": true,
"lastPage": false,
"sort": null,
"size": 2
}
Request Example Details
The example above requests the following:
- The
dataSetsassociated with the connection. - The
limitof connections per page to be2. - The
sortDirectionto beDESC, or descending.
Response Example Details
The example response above shows the following:
- The
dataSetIdvalues used by the connections are5f24c4f6ecffd13h6dXXXXXXand5f1873caa73caa4hf6XXXXXX. - The
typeof dataset used by both connections isevent. - The names of the datasets are
Test Datasetandexample_object_event. - The ID of the connections are
dg_b008fd39-2437-4d00-88fd-392434XXXXXXanddg_7110bb3e-76ce-4201-90bb-3e7656XXXXXX". - The total number of connections for the organization--shown as
totalElements--are573.
Request Parameters
dataSetIdsconnectionIdssandboxIdsandboxNameexpansionname, description, owner, isDeleted, isDisabled, dataSets, createdDate, modified, caseSensitive, organization, components, numDailyEvents, externalData, backfillEnabled, granularBackfills, granularStreaming, backfillsSummaryConnection, backfillsSummaryDataSets, dataSetLastIngested, sandboxName, sandboxId, fieldsId, floatPrecision, dataRetentionMonths, validationErrors, resolveIdentityNamespace, and stitchedDataSets.includeTypecachedlocalelimitpage0.sortDirectionASC and DESC.sortPropertymodifiedDate and id.Response Parameters
The GET all connections endpoint response parameters include all of the response parameters shown above for the GET a connection by ID, in addition to the following:
numbertotalElementstotalPagesnumberOfElementsfirstPagelastPagesortsizeGET backfills
Use this endpoint to retrieve the backfills for a specified connection and dataset.
GET https://cja.adobe.io/data/connections/{CONNECTION_ID}/datasets/{DATASET_ID}/backfills
Request and Response Examples
Click the Request tab in the following example to see a cURL request for this endpoint. Click the Response tab to see a successful JSON response for the request.
data-slots=heading, code
data-repeat=2
data-languages=CURL,JSON
Request
curl 'https://cja.adobe.io/data/connections/dg_47b7fb18-676b-4f04-8fa3-25XXXXXXXXXX/datasets/6526664c54d56dXXXXXXXXXX/backfills' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {IMS_ORG_ID}' \
-H 'Authorization: Bearer {AUTHORIZATION_TOKEN}'
Response
{
"content": [
{
"id": "76ce8f4f-c19b-4e4a-a524-753827XXXXXX",
"dataSetId": "6526664c54d56d4d6tXXXXXX",
"status": "COMPLETED",
"startDate": null,
"endDate": null,
"createdDate": "20XX-10-16T14:06:04.816Z",
"allData": true
},
{
"id": "31821999-d1f8-4526-b754-663562XXXXXX",
"dataSetId": "6526664c54d56d4d6tXXXXXX",
"status": "IN_PROGRESS",
"startDate": null,
"endDate": null,
"createdDate": "20XX-10-16T14:42:34.264Z",
"allData": true
}
],
"number": 0,
"totalElements": 2,
"totalPages": 1,
"numberOfElements": 2,
"firstPage": true,
"lastPage": true,
"sort": null,
"size": 10
}
Request Example Details
The example above requests the backfills associated with the dg_47b7fb18-676b-4f04-8fa3-25XXXXXXXXXX connection and the 6526664c54d56d4d6tXXXXXX dataset.
Response Example Details
The example response above returns the following:
- The dataset
6526664c54d56d4d6tXXXXXXis associated with both backfills. - The status of the
76ce8f4f-c19b-4e4a-a524-753827XXXXXXbackfill isCOMPLETED. - The status of the
31821999-d1f8-4526-b754-66XXXXXXXXXXbackfill isIN_PROGRESS.
Request Parameters
connectionIddatasetIdincludeStatusinProgress, completed, and failed.limitpage0.sortDirectionASC and DESC.sortPropertycreatedDate.Response Parameters
contentid, dataSetId, status, startDate, endDate, createdDate, and allData parameters.iddataSetIdstatusstartDateendDatecreatedDateallDatanumber0.totalElementstotalPagesnumberOfElementsfirstPagelastPagesortsizeGET data source types
Use this endpoint to retrive the data source types used by an organization.
GET https://cja.adobe.io/data/connections/configurationSettings
Request and Response Examples
Click the Request tab in the following example to see a cURL request for this endpoint. Click the Response tab to see a successful JSON response for the request.
data-slots=heading, code
data-repeat=2
data-languages=CURL,JSON
Request
curl 'https://cja.adobe.io/data/connections/configurationSettings' \
-H 'x-api-key: {API_KEY}' \
-H 'x-gw-ims-org-id: {IMS_ORG_ID}' \
-H 'Authorization: Bearer {AUTHORIZATION_TOKEN}
Response
{
"dataSourceTypes": [
{
"id": "webData",
"type": "Web Data"
},
{
"id": "mobileAppData",
"type": "Mobile App Data"
},
{
"id": "posData",
"type": "POS Data"
},
{
"id": "crmData",
"type": "CRM Data"
},
{
"id": "surveyData",
"type": "Survey Data"
},
{
"id": "productData",
"type": "Product Data"
},
{
"id": "callCenterData",
"type": "Call Center Data"
},
{
"id": "accountsData",
"type": "Accounts Data"
},
{
"id": "transactionData",
"type": "Transaction Data"
},
{
"id": "customerFeedbackData",
"type": "Customer Feedback Data"
},
{
"id": "other",
"type": "Other"
}
]
}
Request Example Details
The example above requests the data source types associated with the organization.
Response Example Details
The example response above shows the data source types for the organization.
Request Parameters
localeen_US.Response Parameters
dataSourceTypesid, type, and description parameters.idtypedescriptionB2B Features
In Customer Journey Analytics B2B Edition, you can retreive data for an account-based connection in addition to a person-based connection. A B2B account-based connection facilitates account-based reporting and analysis. Responses with B2B connections can show the following:
-
The
primaryIdTypevalue asaccount, as shown in theexpansionarray for query parameters in the Connections API Reference. -
Additional items in the
configuredContainersexpansion array, includingaccount,globalAccount,opportunity, andbuyingGroup. -
A
containerFieldobject with members as shown below:
"ContainerField": {
"type": "object",
"properties": {
"container": {
"type": "string"
},
"systemFieldValue": {
"type": "string"
}
}
},
For more information on B2B connections, see B2B Edition concepts and features.
API status codes
For a description of API status codes and tips for troubleshooting, see the Platform FAQ and troubleshooting guide.